/*
 * GTHB Gothello Board
 * Bart Massey 12/2001
 *
 * (Based on Tic-Tac-Toe board
 * Bart Massey 6/1995)
 */

#include <stdio.h>
#include "gthb.h"
#include "gthclient.h"
 
enum who humanside = WHO_BLACK;
enum who computerside = WHO_WHITE;
struct board currentboard;
int compfirst;
int won;

enum win whotowin(enum who w) {
  switch (w) {
  case WHO_BLACK:
    return WIN_BLACK;
  case WHO_WHITE:
    return WIN_WHITE;
  case WHO_NONE:
    break;
  }
  abort();
  /*NOTREACHED*/
}

void computermove(struct board *b, enum who w) {
  char movestr[3];
  enum gth_state state = gth_get_move(movestr);
  if (state == GTH_STATE_ERROR) {
    fprintf(stderr, "error talking to server\n");
    abort();
  }
  if (state == GTH_STATE_DONE) {
    won = 1;
    return;
  }
  if (movestr[0] == '.') {
    b->passes++;
    b->movewho = w;
    b->movex = -1;
    b->movey = -1;
    return;
  }
  b->movex = movestr[0] - 'a';
  b->movey = '5' - movestr[1];
  b->movewho = w;
  b->cell[b->movex][b->movey] = w;
  captures(b, b->movex, b->movey, w);
}

void initboard(void) {
  int x, y;
  enum who cwho;

  for (x = 0; x < 5; x++)
      for (y = 0; y < 5; y++)
	  currentboard.cell[x][y] = WHO_NONE;
  currentboard.movewho = WHO_WHITE;
  currentboard.passes = 0;
  won = 0;
  cwho = WHO_BLACK;
  resetboard();
  if (compfirst) {
    humanside = WHO_WHITE;
    computerside = WHO_BLACK;
    cwho = WHO_WHITE;
  }
  start_game(cwho);
}

int main(int argc, char **argv) {
  displayinit(&argc, argv);
  SEED(getpid());
  initboard();
  go();
  abort();
  /*NOTREACHED*/
}
