extern long getpid(void);
extern long lrand48(void);
#ifdef BSD
extern void srandom(long);
extern long random(void);
#define SEED(S) srandom(S)
#define RANDOM(N) ((random()>>2)%(N))
#else
extern void srand48(long);
#define SEED(S) srand48(S)
#define RANDOM(N) ((lrand48()>>2)%(N))
#endif

#define MAX(X,Y) (((X)<(Y))?(Y):(X))

enum who {
  WHO_NONE,
  WHO_BLACK,
  WHO_WHITE
};

enum win {
  WIN_NOTYET,
  WIN_BLACK,
  WIN_WHITE,
  WIN_DRAW
};

struct board {
  enum who cell[5][5];
  int movex, movey;
  enum who movewho;
  int passes;
};

/* gthb.c */

extern enum who humanside;
extern enum who computerside;
extern struct board currentboard;
extern int compfirst;
extern int won;

extern enum win whotowin(enum who w);
extern enum win referee(struct board *b);
extern void computermove(struct board *b, enum who w);
extern void randommove(struct board *b, enum who w);
extern void initboard(void);

/* gthb-ui.c */

extern void start_game(enum who w);
extern void refreshboard(struct board *b);
extern void resetboard(void);
extern void displayinit(int *argcp, char **argv);
extern void go(void);


/* ghtb-ref.c */
extern enum win referee(struct board *b);
extern int legal_move(struct board *b, int x, int y, enum who w);
extern void captures(struct board *b, int x, int y, enum who w);
